/*
 ==============================================================================
 
 DebugWindow.cpp
 Created: 27 Sep 2019 3:19:05pm
 Author:  Stephen Kay
 
 ==============================================================================
 */

#include "JuceHeader.h"
#include "DebugWindow.h"
//#include "MidiDemoMod.h"
#include "ListenersAndBroadcastersTutorial_01.h"

//==============================================================================
DebugWindowComponent::DebugWindowComponent (MainContentComponent& mainRef)
: mainComponent(mainRef)
{
    addAndMakeVisible (checkTheTimeButton);
    checkTheTimeButton.setComponentID("time");
    checkTheTimeButton.addListener (&mainComponent); // [7]

    setSize(300, 400);
}
DebugWindowComponent::~DebugWindowComponent()
{
    checkTheTimeButton.removeListener (&mainComponent);
}

void DebugWindowComponent::paint (Graphics& g)
{
    g.fillAll (getLookAndFeel().findColour (ResizableWindow::backgroundColourId));   // clear the background
}

void DebugWindowComponent::resized()
{
    checkTheTimeButton.setBounds(getLocalBounds().reduced(20).removeFromTop(40));
}



// Debug Window

DebugWindow::DebugWindow(MainContentComponent& mainRef, const String& name, Colour backgroundColour, int buttonsNeeded)
: DocumentWindow(name, backgroundColour, buttonsNeeded)
, debugWindowComponent(mainRef)
{
    setResizable(true, false);
    setUsingNativeTitleBar(true);
    
    // Let the child determine the size, and just define top-left window position here
    setContentOwned(&debugWindowComponent, true);
    setTopLeftPosition(500, 100);
}

void DebugWindow::closeButtonPressed()
{
    debugWindowComponent.getMainComponent().closeDebugWindow(false);
}

