/*
 ==============================================================================
 
 DebugWindow.h
 Created: 27 Sep 2019 3:19:05pm
 Author:  Stephen Kay
 
 ==============================================================================
 */

#pragma once

#include "JuceHeader.h"

//==============================================================================
/*
 */
class MainContentComponent;    // forward declaration

class DebugWindowComponent    : public Component
{
public:
    DebugWindowComponent(MainContentComponent& mainRef);
    ~DebugWindowComponent();
    
    void paint(Graphics& g) override;
    void resized() override;
    
    MainContentComponent& getMainComponent() { return mainComponent; };
    
    void addLabelAndSetStyle (Label& label);
    
protected:
    void updateToggleState (Button* button, String name);
    
private:
    MainContentComponent& mainComponent;
    TextButton checkTheTimeButton {"Check the time..." };
    JUCE_DECLARE_NON_COPYABLE_WITH_LEAK_DETECTOR (DebugWindowComponent)
};

class DebugWindow   : public DocumentWindow
{
public:
    DebugWindow(MainContentComponent& mainRef, const String& name, Colour backgroundColour, int buttonsNeeded);
    
    void closeButtonPressed() override;
    
    DebugWindowComponent& getWindowComponent() { return debugWindowComponent; }
private:
    DebugWindowComponent debugWindowComponent;
    
    JUCE_DECLARE_NON_COPYABLE_WITH_LEAK_DETECTOR (DebugWindow)
};
